!= Module StoreDensCloud
!
! Authors::   SUGIYAMA Ko-ichiro
! Version::   $Id: storedenscloud_1d-3.f90,v 1.1 2011-02-23 17:20:48 yamasita Exp $ 
! Tag Name::  $Name: arare4-20110302 $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
! * ̩٤˴ؤѻͤݴɤ뤿ѿ⥸塼(ʬŷ׻). 
! * û֥롼¤, ʿ̤ݴɤ褦ѹ
! * fillnegative ᤭줺ˤʤ˰ᤷ̤¸٤
!   ֥롼( 2 դ)ɲ
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!

module StoreDensCloud
  !
  !̩٤˴ؤѻͤݴɤ뤿ѿ⥸塼.
  !

  !⥸塼ɤ߹
  use gridset, only:   DimXMin,     & ! x β
    &                  DimXMax,     & ! x ξ
    &                  DimZMin,     & ! z β
    &                  DimZMax,     & ! z ξ
    &                  SpcNum,      & ! number of species
    &                  RegXMin,     & ! x ʪΰβ
    &                  RegXMax        ! x ʪΰξ
  use TimeSet, only:   TimeDisp,    & ! ϻֳִ
    &                  DelTimeLong, & ! Ĺ֥ƥå
    &                  DelTimeShort   ! û֥ƥå

  !ۤηػ
  implicit none

  !°λ
  private

  !
  public StoreDensCloud_Init, StoreDensCloudMeanX, StoreDensCloudClean
  public z_DensCloudAdv, z_DensCloudTurb, z_DensCloudDiff, &
    &    z_DensCloudCond, z_DensCloudFill, z_DensCloudFill2
  public StoreDensCloudAdv,  StoreDensCloudTurb, StoreDensCloudDiff, &
    &    StoreDensCloudCond, StoreDensCloudFill, StoreDensCloudFill2
  public DensCloudAdvTendSum, DensCloudTurbTendSum, DensCloudDiffTendSum, &
    &    DensCloudCondTendSum, DensCloudFillTendSum, DensCloudFillTendSum2

  !ѿ
  real(8), allocatable :: z_DensCloudAdv(:)
  real(8), allocatable :: z_DensCloudTurb(:)
  real(8), allocatable :: z_DensCloudDiff(:)
  real(8), allocatable :: z_DensCloudCond(:)
  real(8), allocatable :: z_DensCloudFill(:)
  real(8), allocatable :: z_DensCloudFill2(:)
  real(8), allocatable :: xz_DensCloudAdv(:,:)
  real(8), allocatable :: xz_DensCloudTurb(:,:)
  real(8), allocatable :: xz_DensCloudDiff(:,:)
  real(8), allocatable :: xz_DensCloudCond(:,:)
  real(8), allocatable :: xz_DensCloudFill(:,:)
  real(8), allocatable :: xz_DensCloudFill2(:,:)

  !save °
  save xz_DensCloudAdv, xz_DensCloudTurb, xz_DensCloudDiff, xz_DensCloudCond
  save xz_DensCloudFill, xz_DensCloudFill2
  save z_DensCloudAdv, z_DensCloudTurb, z_DensCloudDiff, z_DensCloudCond
  save z_DensCloudFill, z_DensCloudFill2

contains

  subroutine StoreDensCloud_Init( )
    !롼

    allocate(     &
      & z_DensCloudAdv(DimZMin:DimZMax),  & 
      & z_DensCloudTurb(DimZMin:DimZMax), &
      & z_DensCloudDiff(DimZMin:DimZMax), &
      & z_DensCloudCond(DimZMin:DimZMax), &
      & z_DensCloudFill(DimZMin:DimZMax), &
      & z_DensCloudFill2(DimZMin:DimZMax), &
      & xz_DensCloudAdv(DimXMin:DimXMax, DimZMin:DimZMax),  & 
      & xz_DensCloudTurb(DimXMin:DimXMax, DimZMin:DimZMax), &
      & xz_DensCloudDiff(DimXMin:DimXMax, DimZMin:DimZMax), &
      & xz_DensCloudCond(DimXMin:DimXMax, DimZMin:DimZMax), &
      & xz_DensCloudFill(DimXMin:DimXMax, DimZMin:DimZMax), &
      & xz_DensCloudFill2(DimXMin:DimXMax, DimZMin:DimZMax)  &
      &  )

    call StoreDensCloudClean

  end subroutine StoreDensCloud_Init


  subroutine StoreDensCloudClean( )
    !ݴɤͤΥꥢ
    
    z_DensCloudAdv  = 0.0d0
    z_DensCloudTurb = 0.0d0
    z_DensCloudDiff = 0.0d0
    z_DensCloudCond = 0.0d0
    z_DensCloudFill = 0.0d0
    z_DensCloudFill2 = 0.0d0

    xz_DensCloudAdv  = 0.0d0
    xz_DensCloudTurb = 0.0d0
    xz_DensCloudDiff = 0.0d0
    xz_DensCloudCond = 0.0d0
    xz_DensCloudFill = 0.0d0
    xz_DensCloudFill2 = 0.0d0
   
!    CalNum  = 1.0d-40    !ػ. 
  end subroutine StoreDensCloudClean


  subroutine StoreDensCloudMeanX( &
    & z_DensCloudAdvWork,         &
    & z_DensCloudTurbWork,        &
    & z_DensCloudDiffWork,        &
    & z_DensCloudCondWork,        &
    & z_DensCloudFillWork,        &
    & z_DensCloudFillWork2 )

    ! ݴɤͤοʿʿ [K/s]
    ! û֥ƥåפ do 롼ʿ
    real(8) :: CalNumShort
    real(8) :: z_DensCloudAdvWork(DimZMin:DimZMax)
    real(8) :: z_DensCloudTurbWork(DimZMin:DimZMax)
    real(8) :: z_DensCloudDiffWork(DimZMin:DimZMax)
    real(8) :: z_DensCloudCondWork(DimZMin:DimZMax)
    real(8) :: z_DensCloudFillWork(DimZMin:DimZMax)
    real(8) :: z_DensCloudFillWork2(DimZMin:DimZMax)

    CalNumShort = 2.0d0 * DelTimeLong / DelTimeShort
    
    
    z_DensCloudAdvWork  = a_MeanX_aa( xz_DensCloudAdv )   / CalNumShort
    z_DensCloudTurbWork = a_MeanX_aa( xz_DensCloudTurb )  / CalNumShort
    z_DensCloudDiffWork = a_MeanX_aa( xz_DensCloudDiff )  / CalNumShort
    z_DensCloudCondWork = a_MeanX_aa( xz_DensCloudCond )  / CalNumShort
    z_DensCloudFillWork = a_MeanX_aa( xz_DensCloudFill )  / CalNumShort
    z_DensCloudFillWork2 = a_MeanX_aa( xz_DensCloudFill2 )  / CalNumShort

  end subroutine StoreDensCloudMeanX


  subroutine StoreDensCloudAdv( Work )
    !ήݴ

    implicit none

    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2  = xz_DensCloudAdv + Work
    xz_DensCloudAdv = Work2

  end subroutine StoreDensCloudAdv


  subroutine StoreDensCloudTurb( Work )
    !ήݴ

    implicit none

    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2   = xz_DensCloudTurb + Work
    xz_DensCloudTurb = Work2

  end subroutine StoreDensCloudTurb


  subroutine StoreDensCloudDiff( Work )
    !ͳȻݴ

    implicit none
    
    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2   = xz_DensCloudDiff + Work
    xz_DensCloudDiff = Work2

  end subroutine StoreDensCloudDiff

  subroutine StoreDensCloudCond( Work )
    !ǮȯǮݴ

    implicit none
    
    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2   = xz_DensCloudCond + Work
    xz_DensCloudCond = Work2

  end subroutine StoreDensCloudCond

  subroutine StoreDensCloudFill( Work )
    !ץˤѲ

    implicit none

    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2     = Work + xz_DensCloudFill
    xz_DensCloudFill = Work2

  end subroutine StoreDensCloudFill

  subroutine StoreDensCloudFill2( Work )
    !ץˤѲ

    implicit none

    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2     = Work + xz_DensCloudFill2
    xz_DensCloudFill2 = Work2

  end subroutine StoreDensCloudFill2


! ()

  subroutine DensCloudAdvTendSum( Work )
    ! 2 \delta t γƻǵ᤿ή tendency ­

    implicit none

    real(8), intent(in)  :: Work(DimZMin:DimZMax)
    real(8)              :: Work2(DimZMin:DimZMax)

    Work2  = z_DensCloudAdv + Work
    z_DensCloudAdv = Work2

    xz_DensCloudAdv  = 0.0d0

  end subroutine DensCloudAdvTendSum


  subroutine DensCloudTurbTendSum( Work )
    ! 2 \delta t γƻǵ᤿ή tendency ­

    implicit none

    real(8), intent(in)  :: Work(DimZMin:DimZMax)
    real(8)              :: Work2(DimZMin:DimZMax)

    Work2   = z_DensCloudTurb + Work
    z_DensCloudTurb = Work2

    xz_DensCloudTurb  = 0.0d0

  end subroutine DensCloudTurbTendSum


  subroutine DensCloudDiffTendSum( Work )
    ! 2 \delta t γƻǵ᤿ͳȻ tendency ­. 
    ! û֥ƥåפΥ롼˹Ԥ xz_DensCloudxxx  ̤
    ! ꥢƤ. 

    implicit none
    
    real(8), intent(in)  :: Work(DimZMin:DimZMax)
    real(8)              :: Work2(DimZMin:DimZMax)

    Work2   = z_DensCloudDiff + Work
    z_DensCloudDiff = Work2

    xz_DensCloudDiff  = 0.0d0

  end subroutine DensCloudDiffTendSum

  subroutine DensCloudCondTendSum( Work )
    ! 2 \delta t γƻǵ᤿ǮǮ tendency ­

    implicit none
    
    real(8), intent(in)  :: Work(DimZMin:DimZMax)
    real(8)              :: Work2(DimZMin:DimZMax)

    Work2   = z_DensCloudCond + Work
    z_DensCloudCond = Work2

    xz_DensCloudCond  = 0.0d0

  end subroutine DensCloudCondTendSum

  subroutine DensCloudFillTendSum( Work )
    ! 2 \delta t γƻǵ᤿ tendency ­

    implicit none

    real(8), intent(in)  :: Work(DimZMin:DimZMax)
    real(8)              :: Work2(DimZMin:DimZMax)

    Work2     = Work + z_DensCloudFill
    z_DensCloudFill = Work2

    xz_DensCloudFill = 0.0d0

  end subroutine DensCloudFillTendSum

  subroutine DensCloudFillTendSum2( Work )
    ! 2 \delta t γƻǵ᤿ tendency ­

    implicit none

    real(8), intent(in)  :: Work(DimZMin:DimZMax)
    real(8)              :: Work2(DimZMin:DimZMax)

    Work2     = Work + z_DensCloudFill2
    z_DensCloudFill2 = Work2

    xz_DensCloudFill2 = 0.0d0

  end subroutine DensCloudFillTendSum2

! (λ)


  function a_MeanX_aa( var ) 
    !
    ! ʿʿͤη׻
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8), intent(in)  :: var(DimXMin:DimXMax, DimZMin:DimZMax)
                                     !ʿѱ黻оݤȤʤѿ
    real(8)              :: a_MeanX_aa(DimZMin:DimZMax)
                                     !ʿʿ

    a_MeanX_aa = sum( var(RegXMin+1:RegXMax, :), 1 ) &
      &           / real(RegXMax - RegXMin, 8) 

  end function a_MeanX_aa
  

end module StoreDensCloud
